{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE LambdaCase #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE PatternSynonyms #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.EC2.Types.ImageTypeValues
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.EC2.Types.ImageTypeValues
  ( ImageTypeValues
      ( ..,
        ImageTypeValues_Kernel,
        ImageTypeValues_Machine,
        ImageTypeValues_Ramdisk
      ),
  )
where

import qualified Amazonka.Core as Core
import qualified Amazonka.Data as Data
import Amazonka.EC2.Internal
import qualified Amazonka.Prelude as Prelude

newtype ImageTypeValues = ImageTypeValues'
  { fromImageTypeValues ::
      Data.Text
  }
  deriving stock
    ( Prelude.Show,
      Prelude.Read,
      Prelude.Eq,
      Prelude.Ord,
      Prelude.Generic
    )
  deriving newtype
    ( Prelude.Hashable,
      Prelude.NFData,
      Data.FromText,
      Data.ToText,
      Data.ToByteString,
      Data.ToLog,
      Data.ToHeader,
      Data.ToQuery,
      Data.FromJSON,
      Data.FromJSONKey,
      Data.ToJSON,
      Data.ToJSONKey,
      Data.FromXML,
      Data.ToXML
    )

pattern ImageTypeValues_Kernel :: ImageTypeValues
pattern ImageTypeValues_Kernel = ImageTypeValues' "kernel"

pattern ImageTypeValues_Machine :: ImageTypeValues
pattern ImageTypeValues_Machine = ImageTypeValues' "machine"

pattern ImageTypeValues_Ramdisk :: ImageTypeValues
pattern ImageTypeValues_Ramdisk = ImageTypeValues' "ramdisk"

{-# COMPLETE
  ImageTypeValues_Kernel,
  ImageTypeValues_Machine,
  ImageTypeValues_Ramdisk,
  ImageTypeValues'
  #-}
