{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DuplicateRecordFields #-}
{-# LANGUAGE NamedFieldPuns #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE RecordWildCards #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-unused-matches #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.EC2.Types.Phase1EncryptionAlgorithmsRequestListValue
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.EC2.Types.Phase1EncryptionAlgorithmsRequestListValue where

import qualified Amazonka.Core as Core
import qualified Amazonka.Core.Lens.Internal as Lens
import qualified Amazonka.Data as Data
import Amazonka.EC2.Internal
import qualified Amazonka.Prelude as Prelude

-- | Specifies the encryption algorithm for the VPN tunnel for phase 1 IKE
-- negotiations.
--
-- /See:/ 'newPhase1EncryptionAlgorithmsRequestListValue' smart constructor.
data Phase1EncryptionAlgorithmsRequestListValue = Phase1EncryptionAlgorithmsRequestListValue'
  { -- | The value for the encryption algorithm.
    value :: Prelude.Maybe Prelude.Text
  }
  deriving (Prelude.Eq, Prelude.Read, Prelude.Show, Prelude.Generic)

-- |
-- Create a value of 'Phase1EncryptionAlgorithmsRequestListValue' with all optional fields omitted.
--
-- Use <https://hackage.haskell.org/package/generic-lens generic-lens> or <https://hackage.haskell.org/package/optics optics> to modify other optional fields.
--
-- The following record fields are available, with the corresponding lenses provided
-- for backwards compatibility:
--
-- 'value', 'phase1EncryptionAlgorithmsRequestListValue_value' - The value for the encryption algorithm.
newPhase1EncryptionAlgorithmsRequestListValue ::
  Phase1EncryptionAlgorithmsRequestListValue
newPhase1EncryptionAlgorithmsRequestListValue =
  Phase1EncryptionAlgorithmsRequestListValue'
    { value =
        Prelude.Nothing
    }

-- | The value for the encryption algorithm.
phase1EncryptionAlgorithmsRequestListValue_value :: Lens.Lens' Phase1EncryptionAlgorithmsRequestListValue (Prelude.Maybe Prelude.Text)
phase1EncryptionAlgorithmsRequestListValue_value = Lens.lens (\Phase1EncryptionAlgorithmsRequestListValue' {value} -> value) (\s@Phase1EncryptionAlgorithmsRequestListValue' {} a -> s {value = a} :: Phase1EncryptionAlgorithmsRequestListValue)

instance
  Prelude.Hashable
    Phase1EncryptionAlgorithmsRequestListValue
  where
  hashWithSalt
    _salt
    Phase1EncryptionAlgorithmsRequestListValue' {..} =
      _salt `Prelude.hashWithSalt` value

instance
  Prelude.NFData
    Phase1EncryptionAlgorithmsRequestListValue
  where
  rnf Phase1EncryptionAlgorithmsRequestListValue' {..} =
    Prelude.rnf value

instance
  Data.ToQuery
    Phase1EncryptionAlgorithmsRequestListValue
  where
  toQuery
    Phase1EncryptionAlgorithmsRequestListValue' {..} =
      Prelude.mconcat ["Value" Data.=: value]
